import schedulingState from './schedulingState';
import withResolvers from './utils/withResolvers';
let isTracking = false;
let idleCallbackId;
export function startTracking() {
    // istanbul ignore next
    if (isTracking) {
        return;
    }
    isTracking = true;
    const reset = () => {
        schedulingState.idleDeadline = undefined;
        schedulingState.isThisFrameBudgetSpent = false;
        schedulingState.thisFrameWorkStartTime = undefined;
    };
    const loop = () => {
        if (typeof requestIdleCallback !== 'undefined') {
            idleCallbackId = requestIdleCallback((deadline) => {
                reset();
                schedulingState.idleDeadline = deadline;
                schedulingState.onIdleCallback.resolve();
                schedulingState.onIdleCallback = withResolvers();
            });
        }
        requestAnimationFrame(() => {
            reset();
            schedulingState.onAnimationFrame.resolve();
            schedulingState.onAnimationFrame = withResolvers();
            if (schedulingState.tasks.length === 0) {
                isTracking = false;
                if (typeof cancelIdleCallback !== 'undefined') {
                    cancelIdleCallback(idleCallbackId);
                }
            }
            else {
                loop();
            }
        });
    };
    loop();
}
